;
;Diagnosticky znalostni system SP410PRO
;Tento system je primarne urceny pro opravy srovnavaci a tloustkovaci
;frezky Jerabek SP410PRO. Ovsem je mozne jej pouzit i pro obdobne
;stroje urcene pro mala a stredni truhlarstvi.
;
;Soucast bakalarske prace zvane "Vyuka reprezentace znalosti"
;
;Autor: Josef Kazak A11B0397P
;
;Datum: 27. 4. 2015
;

;Zde nachazejici se pravidla a poznatky, slouzi pro komunikaci s uzivatelem
;a pro vypis adekvatnich odpovedi na dane problemy. Resi se zde problematika,
;tykajici se srovnavaci funkce frezky. Mezi resenou problematiku patri
;napr. nerovnomerny uber materialu ci problem spojene s pomocnym pravitkem.
;
;Pravidla jsou rozrazena podle urovne zanoreni ve stromu. Kazde pravidlo
;je vyvolano na zaklade jeho urovne zanoreni a poslednich casti slotu „popis“,
;ktery je soucasti faktu/sablony „hypoteza“.

;Uroven 1
(defrule iden-uroven-1-srovnavani
 (aktualni-uroven (hodnota 1))
 (not (nezadouci srovnavani))
=>
 (printout t crlf crlf crlf crlf "      Jedna se o problem se srovnavaci funkci frezky?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne ukoncit) srovnavani))
)

;*********************************************************
;Uroven 2
(defrule iden-uroven-2-nekvalitni-obrobeni
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani))
 (not (nezadouci nekvalitni-obrabeni))
=>
 (printout t crlf crlf crlf crlf "      Hoblovany povrch neni dostatecne hladky ci je ostipany?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) nekvalitni-obrabeni))
)

(defrule iden-uroven-2-nozova-hridel-kope
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani))
 (not (nezadouci hridel-kope))
=>
 (printout t crlf crlf crlf crlf "      Behem srovnavani ma frezka tendenci vrhat material zpet (tzv. \"kope\")?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) hridel-kope))
)

(defrule iden-uroven-2-nerovnomerny-uber-materialu
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani))
 (not (nezadouci nerovnomerny-uber))
=>
 (printout t crlf crlf crlf crlf "      Uber materialu je nerovnomerny?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) nerovnomerny-uber))
)

(defrule iden-uroven-2-material-dre-na-stolech
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani))
 (not (nezadouci material-dre-na-stolech))
=>
 (printout t crlf crlf crlf crlf "      Obrabeny material se na litinovych stolech dre?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) material-dre-na-stolech))
)

(defrule iden-uroven-2-klenba-pri-rovnavani
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani))
 (not (nezadouci pri-srovnavani-vznika-klenba))
=>
 (printout t crlf crlf crlf crlf 
 "      Na obrabene plose materialu se namisto roviny vytvari klenba (po cele" crlf 
 "      delce obrabeneho materialu)?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) pri-srovnavani-vznika-klenba))
)

(defrule iden-uroven-2-frezka-vytrhava-konce-materialu
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani))
 (not (nezadouci frezka-vystipava-konce-materialu))
=>
 (printout t crlf crlf crlf crlf "      Frezka vytrhava konce obrabeneho materialu?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) frezka-vystipava-konce-materialu))
)

(defrule iden-uroven-2-neni-pravy-uhel
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani))
 (not (nezadouci neni-pravy-uhel))
=>
 (printout t crlf crlf crlf crlf "      Neni mozne (pri srovnavani) dosahnou praveho uhlu na obrobku?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) neni-pravy-uhel))
)

(defrule iden-uroven-2-frezka-zastavuje
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani|tloustkovani))
 (not (nezadouci frezka-zastavuje))
=>
 (printout t crlf crlf crlf crlf "      Frezka se behem obrabeni sama zastavuje?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) frezka-zastavuje))
)

(defrule iden-uroven-2-frezka-se-ucpava
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis srovnavani|tloustkovani))
 (not (nezadouci frezka-se-ucpava))
=>
 (printout t crlf crlf crlf crlf "      Frezka se ucpava pilinami/hoblinami?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) frezka-se-ucpava))
)

;*********************************************************
;Uroven 3
(defrule iden-uroven-3-ostre-noze
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? nekvalitni-obrabeni|frezka-zastavuje))
=>
 (printout t crlf crlf crlf crlf 
 "      Jsou hoblovaci noze ostre (to poznate napriklad pricnym" crlf 
 "      pohybem prstu po ostri noze, pokud je citit tahani za pokozku," crlf 
 "      tak jsou ostre)?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) ostre-noze))
)

(defrule iden-uroven-3-noze-spravne-usazeny
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? ?predchozi-pravidlo&hridel-kope|nerovnomerny-uber))
=>
 (printout t crlf crlf crlf crlf "      Jsou hoblovaci noze spravne ulozeny v nozove hrideli?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) noze-spravne-usazeny))
)

(defrule iden-uroven-3-material-dre-na-stolech-POZNATEK
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? material-dre-na-stolech))
=>
 (assert (osetrete-stoly))
)

(defrule iden-uroven-3-srovnavanim-vznika-klenba-POZNATEK
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? pri-srovnavani-vznika-klenba))
=>
 (assert (serizeni-stolu-srovnavani))
)

(defrule iden-uroven-3-frezka-vystipava-konce-materialu-ano-POZNATEK
 (aktualni-uroven (hodnota 3))
 ?teze <- (hypoteza (popis $? frezka-vystipava-konce-materialu ano))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Vytvarejte tlak na obrabeny material rovnomerne a sunte jej" 
 "stale stejnou rychlosti."))
)

(defrule iden-uroven-3-frezka-vystipava-konce-materialu-ne-POZNATEK
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? frezka-vystipava-konce-materialu ne))
=>
 (assert (serizeni-stolu-srovnavani))
)

(defrule iden-uroven-3-frezka-vystipava-konce-materialu
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? frezka-vystipava-konce-materialu))
=>
 (printout t crlf crlf crlf crlf 
 "      Tvori litinove stoly (srovnavani) rovinu (pri nastaveni nuloveho" crlf 
 "      uberu materialu)?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) vystipane-konce-rovne-stoly))
)

(defrule iden-uroven-3-tvori-pravitko-pravy-uhel
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? neni-pravy-uhel))
=>
 (printout t crlf crlf crlf crlf "      Tvori pravitko vuci stolum pravy uhel?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) pravitko-pravy-uhel))
)

(defrule iden-uroven-3-frezka-se-ucpava-hoblinami-POZNATEK
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? frezka-se-ucpava))
=>
 (assert (problem-ucpana-frezka))
)

;*********************************************************
;Uroven 4
(defrule iden-uroven-4-ostre-noze-ne-POZNATEK
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? ostre-noze ne))
=>
 (assert (nabrousit-noze))
)
(defrule iden-uroven-4-ostre-noze-ano-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? nekvalitni-obrabeni ostre-noze ano))
=>
 (modify ?teze (identifikovano ano) (poznatek "Pri obrabeni sunte material rovnomernym pohybem a primerenou rychlosti."))
)
(defrule iden-uroven-4-ostre-noze-2-ano-kolisave-napeti
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? frezka-zastavuje ostre-noze ano))
=>
 (printout t crlf crlf crlf crlf 
 "      Nekolisa napeti v elektricke siti (to poznate tak, ze i jine stroje" crlf 
 "      ztraceji vykon ci se zcela vypinaji)?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) kolisave-napeti))
)

(defrule iden-uroven-4-noze-spravne-usazeny-ano-POZNATEK
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? nerovnomerny-uber noze-spravne-usazeny ano))
=>
 (assert (serizeni-stolu-srovnavani))
)

(defrule iden-uroven-4-noze-spravne-usazeny-ano
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? hridel-kope noze-spravne-usazeny ano))
=>
 (printout t crlf crlf crlf crlf "      Vykazuje nozova hridel neexcentricky pohyb (tzv. \"haze\")?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) neexcentricky-pohyb))
)

(defrule iden-uroven-4-vystipane-konce-rovne-stoly-ne-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? vystipane-konce-rovne-stoly ne))
=>
 (assert (serizeni-stolu-srovnavani))
)

(defrule iden-uroven-4-vystipane-konce-rovne-stoly-ano-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? vystipane-konce-rovne-stoly ano))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Vytvarejte tlak na obrabeny material rovnomerne a sunte jej stale" 
 "stejnou rychlosti."))
)

(defrule iden-uroven-4-pravitko-pravy-uhel-ne-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? pravitko-pravy-uhel ne))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Nastavte pravitko tak, aby tvorilo vuci prvnimu ze stolu srovnavani (tj. stul," 
 "po kterem se obrobek posouva, nez jej zachyti nozova hridel) pravy uhel"
 "(nejlepe pomoci uhelniku)."))
)

(defrule iden-uroven-4-pravitko-pravy-uhel-ano
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? pravitko-pravy-uhel ano))
=>
 (printout t crlf crlf crlf crlf "      Je stycna plocha pravitka v cele delce rovna?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) rovne-pravitko))
)

(defrule iden-uroven-4-noze-spravne-usazeny-ne-POZNATEK
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? noze-spravne-usazeny ne))
=>
 (assert (ulozte-spravne-hoblovaci-noze))
)

;*********************************************************
;Uroven 5
(defrule iden-uroven-5-hridel-excentricka-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? neexcentricky-pohyb ne))
=>
 (assert (nabrousit-noze))
)

(defrule iden-uroven-5-hridel-excentricka-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? neexcentricky-pohyb ano))
=>
 (assert (vymente-nozovou-hridel))
)

(defrule iden-uroven-5-rovne-pravitko-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? rovne-pravitko ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Vymente stycnou plochu pravitka za novou."))
)

(defrule iden-uroven-5-rovne-pravitko-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? rovne-pravitko ano))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkuste obrobit jiny material. Patrne dochazi k postupnemu" 
 "krouceni obrobku."))
)

(defrule iden-uroven-5-kolisave-napeti-ano/nevim-POZNATEK
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? kolisave-napeti ano))
=>
 (assert (problem-elektricke-site))
)

(defrule iden-uroven-5-kolisave-napeti-ne
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? kolisave-napeti ne))
=>
 (printout t crlf crlf crlf crlf "      Jsou klinove remeny (vedouci od motoru k nozove hrideli) v poradku?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne nevim zpet ukoncit) klinove-remeny))
)

;*********************************************************
;Uroven 6
(defrule iden-uroven-6-klinove-remeny-v-poradku-ne/nevim-POZNATEK
 (aktualni-uroven (hodnota 6))
 (hypoteza (popis $? klinove-remeny ne|nevim))
=>
 (assert (klinove-remeny-poskozeny))
)

(defrule iden-uroven-6-klinove-remeny-v-poradku-ne
 (aktualni-uroven (hodnota 6))
 (hypoteza (popis $? klinove-remeny ano))
=>
 (printout t crlf crlf crlf crlf "      Vznikaji behem obrabeni ocelove piliny (tzv. spony)?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) ocelove-piliny))
)

;*********************************************************
;Uroven 7
(defrule iden-uroven-7-ocelove-piliny-ne-POZNATEK
 (aktualni-uroven (hodnota 7))
 ?teze <- (hypoteza (popis $? ocelove-piliny ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Snizte rychlost posunu a uber obrabeneho materialu."))
)

(defrule iden-uroven-7-ocelove-piliny-ano-POZNATEK
 (aktualni-uroven (hodnota 7))
 (hypoteza (popis $? ocelove-piliny ano))
=>
 (assert (kontakt-hob-nozu-s-okolim))
)
