;
;Diagnosticky znalostni system SP410PRO
;Tento system je primarne urceny pro opravy srovnavaci a tloustkovaci
;frezky Jerabek SP410PRO. Ovsem je mozne jej pouzit i pro obdobne
;stroje urcene pro mala a stredni truhlarstvi.
;
;Soucast bakalarske prace zvane "Vyuka reprezentace znalosti"
;
;Autor: Josef Kazak A11B0397P
;
;Datum: 27. 4. 2015
;

;V tomto souboru jsou ulozena pravidla a poznatky, zajistujici komunikaci s uzivatelem
;a vygenerovani reseni danych problemu. Hlavnim zajmem lokalnich pravidel je celkovy
;stav srovnavaci a tloustkovaci frezky. Do teto kategorie spada nekolik problematik,
;jako napr. mechanicke poruchy ci neobvykla hlucnost stroje.
;
;Pravidla jsou rozrazena podle urovne zanoreni ve stromu. Kazde pravidlo
;je vyvolano na zaklade jeho urovne zanoreni a poslednich casti slotu "popis",
;ktery je soucasti faktu/sablony "hypoteza".

;Uroven 1
(defrule iden-uroven-1-stav
 (aktualni-uroven (hodnota 1))
 (not (nezadouci stav-frezky))
=>
 (printout t crlf crlf crlf crlf 
 "      Jedna se o problem se stavem frezky (hlucnost, mechanicke" crlf 
 "      poskozeni, ...)?"
 )
 (assert (odpoved-identifikace (ziskej-odpoved ano ne ukoncit) stav-frezky))
)

;*********************************************************
;Uroven 2
(defrule iden-uroven-2-poskozena-komponenta
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis stav-frezky))
 (not (nezadouci poskozena-komponenta))
=>
 (printout t crlf crlf crlf crlf "      Je poskozena nektera komponenta frezky?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) poskozena-komponenta))
)

(defrule iden-uroven-2-frezka-hluci
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis stav-frezky))
 (not (nezadouci frezka-hluci))
=>
 (printout t crlf crlf crlf crlf "      Frezka vydava neobvykly hluk?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) frezka-hluci))
)

(defrule iden-uroven-2-rychle-ztupene-noze
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis stav-frezky))
 (not (nezadouci rychle-se-ztupujici-noze))
=>
 (printout t crlf crlf crlf crlf "      Hoblovaci noze se velmi rychle ztupuji?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) rychle-se-ztupujici-noze))
)

(defrule iden-uroven-2-frezka-vibruje
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis stav-frezky))
 (not (nezadouci frezka-vibruje))
=>
 (printout t crlf crlf crlf crlf "      Frezka (behem obrabeni) vibruje?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) frezka-vibruje))
)

;*********************************************************
;Uroven 3
(defrule iden-uroven-3-nerovna-litina
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? poskozena-komponenta))
 (not (nezadouci nerovna-litina))
=>
 (printout t crlf crlf crlf crlf "      Litinove stoly jsou nerovne?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) nerovna-litina))
)

(defrule iden-uroven-3-znecistena-litina
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? poskozena-komponenta))
 (not (nezadouci znecistena-litina))
=>
 (printout t crlf crlf crlf crlf "      Litinove stoly znecistuji obrabeny material?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) znecistena-litina))
)

(defrule iden-uroven-3-praskla-litina
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? poskozena-komponenta))
 (not (nezadouci praskla-litina))
=>
 (printout t crlf crlf crlf crlf "      Nektery z litinovych stolu je praskly?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) praskla-litina))
)

(defrule iden-uroven-3-neurcita-komponenta-poskozena
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? poskozena-komponenta))
 (not (nezadouci neurcita-komponenta-poskozena))
=>
 (printout t crlf crlf crlf crlf "      Zavada na jinem dilu frezky?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) neurcita-komponenta-poskozena))
)

(defrule iden-uroven-3-frezka-hluci-POZNATEK
 (aktualni-uroven (hodnota 3))
 ?teze <- (hypoteza (popis $? frezka-hluci))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Pokuste se najit konkretni zdroj hluku a opravit jej. Mezi caste" 
 "zdroje hluku patri loziska (pripadne je namazte). Nebo se chvenim" 
 "stroje uvolnil nektery ze spoju (dany spoj pritahnete/svarte)."))
 (modify ?pomoc (servis ano))
)

(defrule iden-uroven-3-rychle-se-ztupujici-noze
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? rychle-se-ztupujici-noze))
=>
 (printout t crlf crlf crlf crlf "      Vznikaji behem obrabeni ocelove piliny (tzv. spony)?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) vznikaji-ocelove-piliny))
)

(defrule iden-uroven-3-frezka-vibruje-POZNATEK
 (aktualni-uroven (hodnota 3))
 ?teze <- (hypoteza (popis $? frezka-vibruje))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Problem muze mit mnoho pricit. Temi nejcastejsimi jsou:"
 "1. Frezka stoji na nerovnem povrchu."
 "2. Hoblovaci noze nejsou spravne ulozeny v nozove hrideli."
 "3. Hoblovaci noze nemaji identicke rozmery."))
 (modify ?pomoc (servis ano))
)

;*********************************************************
;Uroven 4
(defrule iden-uroven-4-nerovna-litina-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? nerovna-litina))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Nechte stul/stoly zbrousit po cele plose. Pripadne je"
 "nahradte novymi."))
)

(defrule iden-uroven-4-znecistena-litina-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? znecistena-litina))
=>
 (assert (osetrete-stoly))
)

(defrule iden-uroven-4-praskla-litina-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? praskla-litina))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Nechte litinovy stul svarit a zbrousit (pokud to jde)," 
 "jinak jej vymente za novy."))
)

(defrule iden-uroven-4-neurcita-komponenta-poskozena-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? neurcita-komponenta-poskozena))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek "Vymente poskozeny dil za novy."))
 (modify ?pomoc (servis ano))
)

(defrule iden-uroven-4-vznikaji-ocelove-piliny-ne
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? vznikaji-ocelove-piliny ne))
=>
 (printout t crlf crlf crlf crlf "      Je obrabeny material cisty (na povrchu nesmi byt zemina, kameny atd.)?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) cisty-material))
)

(defrule iden-uroven-4-vznikaji-ocelove-piliny-ano-POZNATEK
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? vznikaji-ocelove-piliny ano))
=>
 (assert (kontakt-hob-nozu-s-okolim))
)

;*********************************************************
;Uroven 5
(defrule iden-uroven-5-cisty-material-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? cisty-material ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Ocistete material pred obrabenim."))
)

(defrule iden-uroven-5-cisty-material-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? cisty-material ano))
=>
 (modify ?teze (identifikovano ano) (poznatek "Pouzivejte hoblovaci noze z tvrdsi slitiny."))
)
