;
;Diagnosticky znalostni system SP410PRO
;Tento system je primarne urceny pro opravy srovnavaci a tloustkovaci
;frezky Jerabek SP410PRO. Ovsem je mozne jej pouzit i pro obdobne
;stroje urcene pro mala a stredni truhlarstvi.
;
;Soucast bakalarske prace zvane "Vyuka reprezentace znalosti"
;
;Autor: Josef Kazak A11B0397P
;
;Datum: 27. 4. 2015
;

;Zde se nachazeji pravidla a poznatky, slouzici pro komunikaci a ziskani reseni
;z problematiky, tykajici se tloustkovaci funkce srovnavaci a tloustkovaci frezky.
;Mezi tyto problemy patri napr. nekvalitni obrobeni ci nefunkcni posuvne valce.
;
;Pravidla jsou rozrazena podle urovne zanoreni ve stromu. Kazde pravidlo
;je vyvolano na zaklade jeho urovne zanoreni a poslednich casti slotu „popis“,
;ktery je soucasti faktu/sablony „hypoteza“.

;Uroven 1
(defrule iden-uroven-1-tloustkovani
 (aktualni-uroven (hodnota 1))
 (not (nezadouci tloustkovani))
=>
 (printout t crlf crlf crlf crlf "      Jedna se o problem s tloustkovaci funkci frezky?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne ukoncit) tloustkovani))
)

;*********************************************************
;Uroven 2
(defrule iden-uroven-2-nekvalitni-vysledek-obrobeni
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis tloustkovani))
 (not (nezadouci nekvalitni-obrobeni))
=>
 (printout t crlf crlf crlf crlf "      Nekvalitni vysledek obrobeni?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) nekvalitni-obrobeni))
)

(defrule iden-uroven-2-posuvne-valce
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis tloustkovani))
 (not (nezadouci posuvne-valce))
=>
 (printout t crlf crlf crlf crlf "      Problem s posuvnymi valci?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) posuvne-valce))
)

;Frezka se behem obrabeni sama zastavuje? - je zpracovano v souboru "srovnavani.clp".

(defrule iden-uroven-2-frezka-vrha-zpet
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis tloustkovani))
 (not (nezadouci frezka-vrha-zpet))
=>
 (printout t crlf crlf crlf crlf "      Frezka vrha obrabeny material zpet?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) frezka-vrha-zpet))
)

;Frezka se ucpava pilinami/hoblinami? - je zpracovano v souboru "srovnavani.clp".

(defrule iden-uroven-2-problem-s-litinovym-stolem
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis tloustkovani))
 (not (nezadouci litinovy-stul))
=>
 (printout t crlf crlf crlf crlf "      Problem s litinovym stolem ci pridruzenymi komponentami?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) litinovy-stul))
)

;*********************************************************
;Uroven 3
(defrule iden-uroven-3-posuvne-valce-netoci
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? posuvne-valce))
 (not (nezadouci posuvne-valce-netoci))
=>
 (printout t crlf crlf crlf crlf "      Posuvne valce se netoci?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) posuvne-valce-netoci))
)

(defrule iden-uroven-3-vydrazkovany-valec-je-zaneseny
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? posuvne-valce))
 (not (nezadouci vydrazkovany-valec-zaneseny))
=>
 (printout t crlf crlf crlf crlf "      Vydrazkovany posuvny valec je zaneseny?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) vydrazkovany-valec-zaneseny))
)

(defrule iden-uroven-3-frezka-vrha-zpet-material
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? frezka-vrha-zpet))
=>
 (printout t crlf crlf crlf crlf "      Vykazuje nozova hridel neexcentricky pohyb (tzv. \"haze\")?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) excentricka-hridel))
)

(defrule iden-uroven-3-podelne-ryhy
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? nekvalitni-obrobeni))
 (not (nezadouci podelne-ryhy))
=>
 (printout t crlf crlf crlf crlf "      Vytvari se podelne ryhy na obrabenem materialu?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) podelne-ryhy))
)

(defrule iden-uroven-3-material-neni-ciste-obroben
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? nekvalitni-obrobeni))
 (not (nezadouci spatne-obrobeni))
=>
 (printout t crlf crlf crlf crlf "      Material neni ciste obroben?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) spatne-obrobeni))
)

(defrule iden-uroven-3-pravy-uhel-neni
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? nekvalitni-obrobeni))
 (not (nezadouci pravy-uhel-neni))
=>
 (printout t crlf crlf crlf crlf "      Pri tloustkovani nelze dosahnout praveho uhlu?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) pravy-uhel-neni))
)

(defrule iden-uroven-3-zastavuje-tloustkovani
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? nekvalitni-obrobeni))
 (not (nezadouci zastavuje-tloustkovani))
=>
 (printout t crlf crlf crlf crlf "      Obrabeny material se pri tloustkovani prubezne zastavuje?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) zastavuje-tloustkovani))
)

(defrule iden-uroven-3-nerovnomerne-obrobeni
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? nekvalitni-obrobeni))
 (not (nezadouci nerovnomerne-obrobeni))
=>
 (printout t crlf crlf crlf crlf "      Obrabeny material je na koncich nerovnomerne obroben?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) nerovnomerne-obrobeni))
)

(defrule iden-uroven-3-meni-se-nastavena-vyska
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? litinovy-stul))
 (not (nezadouci meni-se-nastavena-vyska))
=>
 (printout t crlf crlf crlf crlf "      Litinovy stul (behem tloustkovani) meni nastavenou vysku?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) meni-se-nastavena-vyska))
)

(defrule iden-uroven-3-nastaveni-polohy-nefunguje
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? litinovy-stul))
 (not (nezadouci nastaveni-polohy-nefunguje))
=>
 (printout t crlf crlf crlf crlf "      Nastaveni polohy litinoveho stolu ci ustavovaci mechanismus nefunguje?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) nastaveni-polohy-nefunguje))
)

(defrule iden-uroven-3-pomocne-valecky
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? litinovy-stul))
 (not (nezadouci pomocne-valecky))
=>
 (printout t crlf crlf crlf crlf "      Problem s pomocnymi valecky?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) pomocne-valecky))
)

(defrule iden-uroven-3-merici-ryska-rozkalibrovana
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? litinovy-stul))
 (not (nezadouci merici-ryska-rozkalibrovana))
=>
 (printout t crlf crlf crlf crlf "      Merici ryska neukazuje presnou vysku tloustkovani?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) merici-ryska-rozkalibrovana))
)

(defrule iden-uroven-3-numericke-odecitani
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? litinovy-stul))
 (not (nezadouci numericke-odecitani))
=>
 (printout t crlf crlf crlf crlf 
 "      Problem s numerickym odecitanim (zarizeni zobrazujici vyslednou" crlf
 "      tloustku obrabeneho materialu)?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) numericke-odecitani))
)

;*********************************************************
;Uroven 4
(defrule iden-uroven-4-zaneseny-posuvny-valec-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? vydrazkovany-valec-zaneseny))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Valec vycistete a naneste mazivo, zminene v manualu (nepouzivejte prilis" 
 "mastne mazivo, jinak dojde znovu k zaneseni)."))
)

(defrule iden-uroven-4-posuvne-valce-netoci-mechanismus-zapnuty
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? posuvne-valce-netoci))
=>
 (printout t crlf crlf crlf crlf "      Mechanismus posuvu je zapnuty?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) posuv-zapnuty))
)

(defrule iden-uroven-4-excentricka-hridel-ano
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? excentricka-hridel ano))
=>
 (assert (vymente-nozovou-hridel))
)

(defrule iden-uroven-4-excentricka-hridel-ne
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? excentricka-hridel ne))
=>
 (printout t crlf crlf crlf crlf "      Jsou hoblovaci noze spravne ulozeny v nozove hrideli?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) hridel-neexcent-noze-v-poradku))
)

(defrule iden-uroven-4-spatne-obrobeni-POZNATEK
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? spatne-obrobeni))
=>
 (assert (nabrousit-noze))
)

(defrule iden-uroven-4-podelne-ryhy-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? podelne-ryhy))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Odstrante vsechny necistoty z litinoveho stolu. Pripadne nedokonalosti"
 "litiny vybruste."))
)

(defrule iden-uroven-4-pravy-uhel-neni
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? pravy-uhel-neni))
=>
 (printout t crlf crlf crlf crlf 
 "      Byl material (pred tloustkovanim) peclive obroben" crlf 
 "      na srovnavaci frezce?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) bylo-rovnano))
)

(defrule iden-uroven-4-stejna-tloustka-po-cele-delce
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? zastavuje-tloustkovani))
=>
 (printout t crlf crlf crlf crlf "      Ma obrabeny material po sve delce stale stejnou tloustku?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) material-stejna-tloustka))
)

(defrule iden-uroven-4-nerovnomerny-uber-na-koncich
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? nerovnomerne-obrobeni))
=>
 (printout t crlf crlf crlf crlf "      Nerovnomernosti se vytvareji permanentne?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) nerovnomerny-uber-na-koncich))
)

(defrule iden-uroven-4-ustavovaci-paka-ve-spravne-poloze
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? meni-se-nastavena-vyska))
=>
 (printout t crlf crlf crlf crlf "      Je ustavovaci paka ve spravne poloze?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) ustavovaci-paka-nastavena))
)

(defrule iden-uroven-4-nastaveni-polohy-nefunguje-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? nastaveni-polohy-nefunguje))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek "Jedna se o problem mechaniky stroje."))
 (modify ?pomoc (servis ano))
)

(defrule iden-uroven-4-pomocne-valecky-netoci
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? pomocne-valecky))
 (not (nezadouci pomocne-valecky-netoci))
=>
 (printout t crlf crlf crlf crlf "      Pomocne valecky se netoci?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) pomocne-valecky-netoci))
)

(defrule iden-uroven-4-pomocne-valecky-spatne-nastaveny
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? pomocne-valecky))
 (not (nezadouci pomocne-valecky-spatne-nastaveny))
=>
 (printout t crlf crlf crlf crlf "      Pomocne valecky jsou prilis vysoko/nizko v litinovem stole?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) pomocne-valecky-spatne-nastaveny))
)

(defrule iden-uroven-4-merici-ryska-rozkalibrovana-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? merici-ryska-rozkalibrovana))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Obrobte material na libovolnou vysku. Pote zmerte obrobek kalibrovanym"
 "metrem. Nakonec posunte merici rysku na spravnou pozici."))
)

(defrule iden-uroven-4-numericke-odecitani-nepravdive
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? numericke-odecitani))
 (not (nezadouci numericke-odecitani-nepravdive))
=>
 (printout t crlf crlf crlf crlf "      Numericke odecitani nezobrazuje pravdive hodnoty?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) numericke-odecitani-nepravdive))
)

(defrule iden-uroven-4-numericke-odecitani-nefunguje
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? numericke-odecitani))
 (not (nezadouci numericke-odecitani-nefunguje))
=>
 (printout t crlf crlf crlf crlf "      Numericke odecitani nefunguje?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) numericke-odecitani-nefunguje))
)

;*********************************************************
;Uroven 5
(defrule iden-uroven-5-hridel-posuv-vypnuty-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? posuv-zapnuty ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Zapnete mechanismus posuvu."))
)

(defrule iden-uroven-5-hnaci-retezy-v-poradku
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? posuv-zapnuty ano))
=>
 (printout t crlf crlf crlf crlf 
 "      Hnaci retezy (vedene od mechanicke spojky k ozubenym kolum posuvnych" crlf 
 "      valcu) jsou v poradku?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne nevim zpet ukoncit) retezy-posuvu-v-poradku))
)

(defrule iden-uroven-5-excentricka-hridel-ne-noze-v-poradku-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? hridel-neexcent-noze-v-poradku ne))
=>
 (assert (ulozte-spravne-hoblovaci-noze))
)

(defrule iden-uroven-5-excentricka-hridel-ne-noze-v-poradku-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? hridel-neexcent-noze-v-poradku ano))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkontrolujte kliny, zabranujici zpetnemu vrhu obrabeneho materialu," 
 "zda nejsou poskozene, jsou dostatecne ostre a zda se svevolne vraci" 
 "do vychozi polohy. Pripadne je tedy namazte, nabruste ci vymente."))
)

(defrule iden-uroven-5-bylo-rovnano-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? bylo-rovnano ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Obrabeny material nejprve zpracujte pomoci srovnavaci frezky."))
)

(defrule iden-uroven-5-bylo-rovnano-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? bylo-rovnano ano))
=>
 (printout t crlf crlf crlf crlf "      Jsou hoblovaci noze spravne ulozeny v nozove hrideli?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) spatny-litinovy-stul-noze-v-poradku))
)

(defrule iden-uroven-5-material-stejna-tloustka-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? material-stejna-tloustka ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Obrobte nerovnosti materialu nejprve pomoci srovnavaci frezky."))
)

(defrule iden-uroven-5-material-stejna-tloustka-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? material-stejna-tloustka ano))
=>
 (assert (osetrete-stoly))
)

(defrule iden-uroven-5-nerovnomerny-uber-na-koncich-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? nerovnomerny-uber-na-koncich ne))
=>
 (assert (upravte-pomocne-valecky))
)

(defrule iden-uroven-5-nerovnomerny-uber-na-koncich-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? nerovnomerny-uber-na-koncich ano))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Radne manipulujte s obrabenym materialem (jak pri podavani," 
 "tak odberu z frezky)."))
)

(defrule iden-uroven-5-ustavovaci-paka-nastavena-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? ustavovaci-paka-nastavena ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Zajistete nastavenou vysku pomoci ustavovaci paky."))
)

(defrule iden-uroven-5-ustavovaci-paka-nastavena-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? ustavovaci-paka-nastavena ano))
=>
 (modify ?teze (identifikovano ano) (poznatek "Pred tloustkovanim obrobte nerovnosti srovnavaci frezkou."))
)

(defrule iden-uroven-5-pomocne-valecky-spatne-nastaveny-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? pomocne-valecky-spatne-nastaveny))
=>
 (assert (upravte-pomocne-valecky))
)

(defrule iden-uroven-5-ciste-draky-ve-stole
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? pomocne-valecky-netoci))
=>
 (printout t crlf crlf crlf crlf "      Je cisto v drazkach mezi valecky a litinovym stolem?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) ciste-drazky-ve-stole))
)

(defrule iden-uroven-5-numericke-odecitani-nepravdive-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? numericke-odecitani-nepravdive))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zarizeni demontujte. Rucne nastavte aktualni vysku tloustkovani"
 "a zarizeni namontujte zpet."))
)

(defrule iden-uroven-5-numericke-odecitani-nefunguje-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? numericke-odecitani-nefunguje))
=>
 (modify ?teze (identifikovano ano) (poznatek "Vymente zarizeni za nove."))
)

;*********************************************************
;Uroven 6
(defrule iden-uroven-6-hnaci-retezy-v-poradku-ne-POZNATEK
 (aktualni-uroven (hodnota 6))
 ?teze <- (hypoteza (popis $? retezy-posuvu-v-poradku ne|nevim))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkontrolujte, zda jsou retezy napnute (pri zapnute mechanicke spojce)"
 "a spravne nabihaji na ozubena kolecka. Pri zjisteni zavady retezy zkratte"
 "nebo vymente za nove."))
 (modify ?pomoc (servis ano))
)

(defrule iden-uroven-6-hnaci-retezy-v-poradku-ano-POZNATEK
 (aktualni-uroven (hodnota 6))
 ?teze <- (hypoteza (popis $? retezy-posuvu-v-poradku ano))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkontrolujte, zda nejsou zadrena loziska mechanickeho posuvu. Pripadne" 
 "je vymente za nova."))
 (modify ?pomoc (servis ano))
)

(defrule iden-uroven-6-spatny-litinovy-stul-noze-v-poradku-ne-POZNATEK
 (aktualni-uroven (hodnota 6))
 (hypoteza (popis $? spatny-litinovy-stul-noze-v-poradku ne))
=>
 (assert (ulozte-spravne-hoblovaci-noze))
)

(defrule iden-uroven-6-spatny-litinovy-stul-noze-v-poradku-ano-POZNATEK
 (aktualni-uroven (hodnota 6))
 ?teze <- (hypoteza (popis $? spatny-litinovy-stul-noze-v-poradku ano))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Nastavte litinovy stul do vodoroviny. K tomu slouzi zarizeni umistena"
 "na spojich pritlacnych pistu s litinovym stolem."))
)

(defrule iden-uroven-6-ciste-drazky-ve-stole-ne-POZNATEK
 (aktualni-uroven (hodnota 6))
 ?teze <- (hypoteza (popis $? ciste-drazky-ve-stole ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Vycistete drazky mezi valecky a litinovym stolem."))
)

(defrule iden-uroven-6-ciste-drazky-ve-stole-ano-POZNATEK
 (aktualni-uroven (hodnota 6))
 ?teze <- (hypoteza (popis $? ciste-drazky-ve-stole ano))
=>
 (modify ?teze (identifikovano ano) (poznatek "Vymente loziska ulozena uvnitr pomocnych valecku."))
)
