;
;Diagnosticky znalostni system SP410PRO
;Tento system je primarne urceny pro opravy srovnavaci a tloustkovaci
;frezky Jerabek SP410PRO. Ovsem je mozne jej pouzit i pro obdobne
;stroje urcene pro mala a stredni truhlarstvi.
;
;Soucast bakalarske prace zvane "Vyuka reprezentace znalosti"
;
;Autor: Josef Kazak A11B0397P
;
;Datum: 27. 4. 2015
;

;V souboru se vyskytuji pouze pravidla a poznatky, zajistujici komunikaci
;s uzivatelem a obsahujici reseni danych problemu. Resenou problematikou
;je zde vypinani srovnavaci a tloustkovaci frezky. K resenym problemum
;patri napr. nefunkcnost elektromagneticke brzdy.
;
;Pravidla jsou rozrazena podle urovne zanoreni ve stromu. Kazde pravidlo
;je vyvolano na zaklade jeho urovne zanoreni a poslednich casti slotu „popis“,
;ktery je soucasti faktu/sablony „hypoteza“.

;Uroven 1
(defrule iden-uroven-1-vypnuti
 (aktualni-uroven (hodnota 1))
 (not (nezadouci vypnuti))
=>
 (printout t crlf crlf crlf crlf "      Jedna se o problem s vypnutim frezky?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne ukoncit) vypnuti))
)

;*********************************************************
;Uroven 2
(defrule iden-uroven-2-frezka-nevypina
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis vypnuti))
 (not (nezadouci frezka-nevypina))
=>
 (printout t crlf crlf crlf crlf "      Frezka nereaguje na vypinaci tlacitko?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) frezka-nevypina))
)

(defrule iden-uroven-2-problem-elmag-brzda
 (aktualni-uroven (hodnota 2))
 (frezka (elmag-brzda ano))
 (hypoteza (popis vypnuti))
 (not (nezadouci problem-elmag-brzda))
=>
 (printout t crlf crlf crlf crlf 
 "      Problem s elektromagnetickou brzdou (nozova hridel se po stisknuti" crlf 
 "      vypinaciho tlacitka frezky toci dele nez 15 sekund ci je z frezky" crlf
 "      vydavan hluk, i kdyz se nozova hridel jiz netoci, ...)?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) problem-elmag-brzda))
)

;*********************************************************
;Uroven 3
(defrule iden-uroven-3-nereaguje-na-vypnuti-POZNATEK
 (aktualni-uroven (hodnota 3))
 ?teze <- (hypoteza (popis $? frezka-nevypina))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkontrolujte, zda nejsou uvolnene vodice ci zoxidovane kontakty" 
 "v hlavnim vypinaci frezky."))
 (modify ?pomoc (servis ano))
)

(defrule iden-uroven-3-elmag-brzda-nefunguje
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? problem-elmag-brzda))
 (not (nezadouci nefunguje-elmag-brzda))
=>
 (printout t crlf crlf crlf crlf 
 "      Elektromagneticka brzda nevykazuje znamky funkcnosti (brzda neni" crlf 
 "      pri vypinani frezky slyset a nozova hridel se po vypnuti stroje" crlf
 "      toci dele nez 15 sekund)?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) nefunguje-elmag-brzda))
)

(defrule iden-uroven-3-prilis-dlouho-hluk
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? problem-elmag-brzda))
 (not (nezadouci prilis-dlouho-hluk))
=>
 (printout t crlf crlf crlf crlf 
 "      Po vypnuti stroje je vydavan hluk z motoru (i kdyz se nozova" crlf 
 "      hridel jiz netoci)?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) prilis-dlouho-hluk))
)

(defrule iden-uroven-3-neefektivni-brzda
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? problem-elmag-brzda))
 (not (nezadouci neefektivni-elmag-brzda))
=>
 (printout t crlf crlf crlf crlf 
 "      Elektromagneticka brzda je pri vypinani frezky slyset, ale nozova" crlf 
 "      hridel se toci dele nez 15 sekund?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) neefektivni-elmag-brzda))
)

;*********************************************************
;Uroven 4
(defrule iden-uroven-4-elmag-brzda-nefunguje-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? nefunguje-elmag-brzda))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Vymente prepetovou pojistku, pokud se problem pretrva, pak vymente" 
 "cely ridici modul (umisteny v hlavnim vypinaci) za novy."))
 (modify ?pomoc (servis ano))
)

(defrule iden-uroven-4-prilis-dlouho-hluk-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? prilis-dlouho-hluk))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkratte brzdici interval pomoci potenciometru umisteneho v leve" 
 "casti modulu rizeni (v hlavnim vypinaci). Pro zkraceni intervalu"
 "otacejte proti smeru hodinovych rucicek."))
)

(defrule iden-uroven-4-neefektivni-elmag-brzda-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? neefektivni-elmag-brzda))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Nastavte potenciometr (umisteny v leve casti modulu rizeni" 
 "v hlavnim vypinaci) na delsi brzdici interval (pro prodlouzeni"
 "intervalu otacejte po smeru hodinovych rucicek)."))
)
