;
;Diagnosticky znalostni system SP410PRO
;Tento system je primarne urceny pro opravy srovnavaci a tloustkovaci
;frezky Jerabek SP410PRO. Ovsem je mozne jej pouzit i pro obdobne
;stroje urcene pro mala a stredni truhlarstvi.
;
;Soucast bakalarske prace zvane "Vyuka reprezentace znalosti"
;
;Autor: Josef Kazak A11B0397P
;
;Datum: 27. 4. 2015
;

;Pravidla a poznatky, nachazejici se v tomto souboru, zajistuji komunikaci s uzivatelem
;a vygenerovani reseni danych problemu. Je zde resena problematika, tykajici se zapnuti
;srovnavaci a tloustkovaci frezky, jako napr. opacne otaceni nozove hridele.
;
;Pravidla jsou rozrazena podle urovne zanoreni ve stromu. Kazde pravidlo
;je vyvolano na zaklade jeho urovne zanoreni a poslednich casti slotu „popis“,
;ktery je soucasti faktu/sablony „hypoteza“.

;Uroven 1
(defrule iden-uroven-1-zapnuti
 (aktualni-uroven (hodnota 1))
 (not (nezadouci zapnuti))
=>
 (printout t crlf crlf crlf crlf "      Jedna se o problem se zapnutim frezky?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne ukoncit) zapnuti))
)

;*********************************************************
;Uroven 2
(defrule iden-uroven-2-zadna-reakce
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis zapnuti))
 (not (nezadouci zadna-reakce))
=>
 (printout t crlf crlf crlf crlf "      Po stisknuti startovaciho tlacitka nenastane zadna reakce?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) zadna-reakce))
)

(defrule iden-uroven-2-hridel-netoci
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis zapnuti))
 (not (nezadouci hridel-netoci))
=>
 (printout t crlf crlf crlf crlf "      Motor je slyset, ale nozova hridel se netoci?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) hridel-netoci))
)

(defrule iden-uroven-2-opacny-smer
 (aktualni-uroven (hodnota 2))
 (hypoteza (popis zapnuti))
 (not (nezadouci opacny-smer))
=>
 (printout t crlf crlf crlf crlf "      Nozova hridel se otaci opacnym smerem?")
 (assert (odpoved-identifikace (ziskej-odpoved ano ne zpet ukoncit) opacny-smer))
)

;*********************************************************
;Uroven 3
(defrule iden-uroven-3-opacny-smer-POZNATEK
 (aktualni-uroven (hodnota 3))
 ?teze <- (hypoteza (popis $? opacny-smer))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek "Vymente 2 faze na privodnim kabelu."))
 (modify ?pomoc (elektrikar ano))
)

(defrule iden-uroven-3-je-zapojena
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? zadna-reakce))
=>
 (printout t crlf crlf crlf crlf "      Je frezka zapojena do elektricke site?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) je-zapojena))
)

(defrule iden-uroven-3-neobvykle-zvuky
 (aktualni-uroven (hodnota 3))
 (hypoteza (popis $? hridel-netoci))
=>
 (printout t crlf crlf crlf crlf 
 "      Vydavala frezka pri poslednim pouzivani neobvykle (pronikave)" crlf
 "      zvuky (z oblasti nozove hridele ci motoru)?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) neobvykle-zvuky))
)

;*********************************************************
;Uroven 4
(defrule iden-uroven-4-je-zapojena-ne-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? je-zapojena ne))
=>
 (modify ?teze (identifikovano ano) (poznatek "Zapojte frezku do elektricke site."))
)

(defrule iden-uroven-4-je-zapojena-ano
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis zapnuti zadna-reakce je-zapojena ano))
=>
 (printout t crlf crlf crlf crlf
 "      Jde elektricky proud do frezky? Pritomnost proudu overite v zastrcce," crlf
 "      do ktere je stroj pripojen, napriklad pomoci zkousecky napeti nebo" crlf
 "      zapojenim (a spustenim) jineho stroje do dane zastrcky.")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) jde-proud))
)

(defrule iden-uroven-4-neobvykle-zvuky-ano-POZNATEK
 (aktualni-uroven (hodnota 4))
 ?teze <- (hypoteza (popis $? neobvykle-zvuky ano))
=>
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkontrolujte, zda nejsou zadrena loziska nozove hridele," 
 "pripadne je nahradte."))
)

(defrule iden-uroven-4-neobvykle-zvuky-ne
 (aktualni-uroven (hodnota 4))
 (hypoteza (popis $? neobvykle-zvuky ne))
=>
 (printout t crlf crlf crlf crlf "      Je cisto v okoli nozove hridele a noze jsou spravne ulozeny?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) je-cisto))
)

;*********************************************************
;Uroven 5
(defrule iden-uroven-5-jde-proud-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? jde-proud ne))
=>
 (assert (problem-elektricke-site))
)

(defrule iden-uroven-5-jde-proud-ano
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? jde-proud ano))
=>
 (printout t crlf crlf crlf crlf "      Byla pred nekolika malo chvilemi frezka pouzivana?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano ne zpet ukoncit) teplotni-pojistka))
)

(defrule iden-uroven-5-je-cisto-ano-POZNATEK
 (aktualni-uroven (hodnota 5))
 (hypoteza (popis $? je-cisto ano))
=>
 (assert (klinove-remeny-poskozeny))
)

(defrule iden-uroven-5-je-cisto-ne-POZNATEK
 (aktualni-uroven (hodnota 5))
 ?teze <- (hypoteza (popis $? je-cisto ne))
=>
 (modify ?teze (identifikovano ano) (poznatek
 "Vycistete prostor nozove hridele, pripadne spravne ulozte hoblovaci noze."
 "Navod na ulozeni nozu - vizte prirucka stroje."))
)

;*********************************************************
;Uroven 6
(defrule iden-uroven-6-byla-frezka-pouzivana-ano-POZNATEK
 (aktualni-uroven (hodnota 6))
 ?teze <- (hypoteza (popis $? teplotni-pojistka ano))
=>
 (modify ?teze (identifikovano ano) (poznatek
 "Vyckejte chvili (nez se motor ochladi) a teplotni pojistka Vam"
 "dovoli frezku spustit."))
)

(defrule iden-uroven-6-byla-frezka-pouzivana-ne
 (aktualni-uroven (hodnota 6))
 (hypoteza (popis $? teplotni-pojistka ne))
=>
 (printout t crlf crlf crlf crlf "      Je prepetova pojistka v poradku?")
 (assert (odpoved-rozhodnuti (ziskej-odpoved ano nevim ne zpet ukoncit) prepetova-pojistka))
)

;*********************************************************
;Uroven 7
(defrule iden-uroven-7-prepetova-pojistka-v-poradku-ne/nevim-POZNATEK
 (aktualni-uroven (hodnota 7))
 ?teze <- (hypoteza (popis $? prepetova-pojistka ne|nevim))
=>
 (modify ?teze (identifikovano ano) (poznatek
 "Vymente prepetovou pojistku. Pojistka se nachazi v horni casti"
 "modulu rizeni (v hlavnim vypinaci)."))
)

(defrule iden-uroven-7-prepetova-pojistka-v-poradku-ano-POZNATEK
 (aktualni-uroven (hodnota 7))
 ?teze <- (hypoteza (popis $? prepetova-pojistka ano))
 ?pomoc <- (odborna-pomoc)
=>
 (modify ?teze (identifikovano ano) (poznatek
 "Zkontrolujte nasledujici (caste) zdroje techto problemu:"
 "- Zda jsou sepnuty vsechny ochranne systemy"
 "- Velikost uhliku v motoru (pri jejich opotrebeni je nutna vymena)"
 "- Zda nejsou zoxidovane kontakty ci uvolnene vodice"))
 (modify ?pomoc (servis ano))
)