;
;Diagnosticky znalostni system SP410PRO
;Tento system je primarne urceny pro opravy srovnavaci a tloustkovaci
;frezky Jerabek SP410PRO. Ovsem je mozne jej pouzit i pro obdobne
;stroje urcene pro mala a stredni truhlarstvi.
;
;Soucast bakalarske prace zvane "Vyuka reprezentace znalosti"
;
;Autor: Josef Kazak A11B0397P
;
;Datum: 27. 4. 2015
;

;Zde jsou ulozeny tzv. "univerzalni" poznatky. Kazdy z techto poznatku je vypisovan pro vice hypotez.

(defrule iden-uroven-?-tupe-noze
 ?noze <- (nabrousit-noze)
 ?teze <- (hypoteza)
=>
 (retract ?noze)
 (modify ?teze (identifikovano ano) (poznatek 
 "Podle stavu jednotlivych nozu je bud nabruste primo v nozove hrideli" 
 "(pomoci honovaciho kamene) nebo je vymente za jine (ci nove)."))
)

(defrule iden-uroven-?-serizeni-stolu-srovnavani
 ?serizeni <- (serizeni-stolu-srovnavani)
 ?teze <- (hypoteza)
=>
 (retract ?serizeni)
 (modify ?teze (identifikovano ano) (poznatek 
 "Seridte oba litinove stoly tak, aby pri nastavenem nulovem uberu" 
 "tvorily rovinu. Vysledna rovina musi byt rovnobezna s nozovou hrideli."))
)

(defrule iden-uroven-?-poskozene-klinove-remeny
 ?remeny <- (klinove-remeny-poskozeny)
 ?teze <- (hypoteza)
=>
 (retract ?remeny)
 (modify ?teze (identifikovano ano) (poznatek 
 "Zkontrolujte klinove remeny (vedouci od motoru k nozove hrideli). Pokud"
 "jsou poskozene, pak je ihned vymente. A pokud volne, tak je napnete"
 "(napinacim zarizenim, umistenym pod motorem)."))
)

(defrule iden-uroven-?-problem-el-site
 ?problem <- (problem-elektricke-site)
 ?teze <- (hypoteza)
 ?pomoc <- (odborna-pomoc)
=>
 (retract ?problem)
 (modify ?teze (identifikovano ano) (poznatek 
 "Jedna se o problem elektricke site, ktery je nutne opravit. Ovsem" 
 "touto problematikou se jiz tento system nezaobira."))
 (modify ?pomoc (elektrikar ano))
)

(defrule iden-uroven-?-frezka-se-ucpava
 ?problem <- (problem-ucpana-frezka)
 ?teze <- (hypoteza)
=>
 (retract ?problem)
 (modify ?teze (identifikovano ano) (poznatek "Zvyste vykon odsavani a snizte rychlost posunu obrabeneho materialu."))
)


(defrule iden-uroven-?-spravne-ulozeni-hoblovacich-nozu
 ?noze <- (ulozte-spravne-hoblovaci-noze)
 ?teze <- (hypoteza)
=>
 (retract ?noze)
 (modify ?teze (identifikovano ano) (poznatek 
 "Vlozte hoblovaci noze do hridele spravne, tzn. se stejnou vyskou" 
 "ostri (vycnivajici z nozove hridele) a se spravnym vycentrovanim." 
 "Pro spravne ulozeni nozu je vhodne pouzit ustavovaci pripravek."))
)

(defrule iden-uroven-?-osetreni-litinovych-stolu
 ?problem <- (osetrete-stoly)
 ?teze <- (hypoteza)
=>
 (retract ?problem)
 (modify ?teze (identifikovano ano) (poznatek 
 "Vycistete stul/stoly neagresivnim prostredkem a pote je znovu"
 "osetrete pripravkem na zvyseni kluznosti."))
)

(defrule iden-uroven-?-excentricka-hridel
 ?hridel <- (vymente-nozovou-hridel)
 ?teze <- (hypoteza)
=>
 (retract ?hridel)
 (modify ?teze (identifikovano ano) (poznatek 
 "Nechte stavajici nozovou hridel vystredit (ve specializovanem" 
 "stredisku) nebo ji vymente za novou."))
)

(defrule iden-uroven-?-uprava-nastaveni-pomocnych-valecku
 ?valce <- (upravte-pomocne-valecky)
 ?teze <- (hypoteza)
=>
 (retract ?valce)
 (modify ?teze (identifikovano ano) (poznatek 
 "Upravte nastaveni pomocnych valecku (nachazejici se v litinovem" 
 "stole). Nejvyssi bod valce by mel byt zhruba 0,8 mm nad povrchem" 
 "litinoveho stolu."))
)

(defrule iden-uroven-?-vznikaji-ocelove-piliny
 ?kontakt <- (kontakt-hob-nozu-s-okolim)
 ?teze <- (hypoteza)
 ?pomoc <- (odborna-pomoc)
=>
 (retract ?kontakt)
 (modify ?teze (identifikovano ano) (poznatek 
 "Dochazi ke kontaktu hoblovacich nozu s nekterou z okolnich" 
 "komponent. Tuto zavadu je nutne odstranit."))
 (modify ?pomoc (servis ano))
)
